/**
 * @fileOverview jui_filter_rules is a jQuery plugin, useful to create dataset filter rules as JSON object and the relevant WHERE SQL.
 *               <p>License MIT
 *               <br />Copyright 2012 Christos Pontikis <a href="http://pontikis.net">http://pontikis.net</a>
 *               <br />Project page <a href="http://pontikis.net/labs/jui_filter_rules">http://pontikis.net/labs/jui_filter_rules</a>
 *               <br />Minified using Online YUI Compressor http://www.refresh-sf.com/yui/
 * @version 1.00 (24 Jan 2012)
 * @author Christos Pontikis http://pontikis.net
 * @requires jquery, (optional but highly recommended moment.js, jquery-ui)
 */
"use strict";(function(e){var a="jui_filter_rules",h="jui_filter_rules_status",g=["text","number","date"],r=[{type:"equal",accept_values:"yes",apply_to:["text","number","date"],group:"equality"},{type:"not_equal",accept_values:"yes",apply_to:["text","number","date"],group:"equality"},{type:"in",accept_values:"yes",apply_to:["text","number","date"],group:"multiple_choice"},{type:"not_in",accept_values:"yes",apply_to:["text","number","date"],group:"multiple_choice"},{type:"less",accept_values:"yes",apply_to:["number","date"],group:"inequality"},{type:"less_or_equal",accept_values:"yes",apply_to:["number","date"],group:"inequality"},{type:"greater",accept_values:"yes",apply_to:["number","date"],group:"inequality"},{type:"greater_or_equal",accept_values:"yes",apply_to:["number","date"],group:"inequality"},{type:"begins_with",accept_values:"yes",apply_to:["text"],group:"substring"},{type:"not_begins_with",accept_values:"yes",apply_to:["text"],group:"substring"},{type:"contains",accept_values:"yes",apply_to:["text"],group:"substring"},{type:"not_contains",accept_values:"yes",apply_to:["text"],group:"substring"},{type:"ends_with",accept_values:"yes",apply_to:["text"],group:"substring"},{type:"not_ends_with",accept_values:"yes",apply_to:["text"],group:"substring"},{type:"is_empty",accept_values:"no",apply_to:["text"],group:"empty_string"},{type:"is_not_empty",accept_values:"no",apply_to:["text"],group:"empty_string"},{type:"is_null",accept_values:"no",apply_to:["text","number","date"],group:"null"},{type:"is_not_null",accept_values:"no",apply_to:["text","number","date"],group:"null"}];var w={init:function(A){var B=this;return this.each(function(){var X=B.data(a);if(typeof(X)=="undefined"){var M=B.jui_filter_rules("getDefaults");X=e.extend({},M,A)}else{X=e.extend({},X,A)}B.data(a,X);if(typeof B.data(h)==="undefined"){B.data(h,{});B.data(h)["group_id"]=0;B.data(h)["rule_id"]=0}var U=B.attr("id");d(U);B.unbind("onValidationError").bind("onValidationError",X.onValidationError);var K=X.filters,R=n(X.filters_list_id_prefix,U)+"_",T=n(X.operators_container_id_prefix,U)+"_",L=n(X.operators_list_id_prefix,U)+"_",I,D=n(X.filter_value_container_id_prefix,U)+"_",Q=n(X.group_condition_id_prefix,U)+"_",W=n(X.group_tools_id_prefix,U)+"_",O=n(X.rule_tools_id_prefix,U)+"_",F,J,Z,Y,P,ad,ab,ac,S,V,H,E,N,aa,G=X.rulesListLiAppliedClass,C=X.rulesListLiErrorClass;if(B.data(h)["rule_id"]==0){if(K.length>0){B.html(o(U))}else{B.html('<div class="'+X.noFiltersFoundClass+'">'+rsc_jui_fr.no_filters_found+"</div>")}}B.addClass(X.containerClass);S='[id^="'+W+'"]';B.off("change",S).on("change",S,function(){V=W.length;H=e(this).attr("id").substr(V);N=e(this).val();switch(N){case"rule_insert_before":e(this).closest("dt").parent("dl").before(m(U));break;case"rule_insert_after":e(this).closest("dt").parent("dl").after(m(U));break;case"rule_insert_inside":e(this).closest("dt").next("dd:first").find("ul:first").prepend(m(U));break;case"group_insert_before":e(this).closest("dl").before(o(U));break;case"group_insert_after":e(this).closest("dl").after(o(U));break;case"group_insert_inside":e(this).closest("dt").next("dd:first").find("ul:first").prepend(o(U));break;case"group_delete":e(this).closest("dl").remove();break}e(this).prop("selectedIndex",0)});S='[id^="'+O+'"]';B.off("change",S).on("change",S,function(){V=O.length;H=e(this).attr("id").substr(V);aa=e(this).val();switch(aa){case"rule_insert_before":e(this).closest("li").before(m(U));break;case"rule_insert_after":e(this).closest("li").after(m(U));break;case"rule_clear":F=R+H;Z=T+H;Y=D+H;P=e("#"+F);ab=e("#"+Z);ac=e("#"+Y);P.prop("selectedIndex",0);ab.html("");ac.html("");B.jui_filter_rules("markRuleAsPending",e(this).closest("li").attr("id"));break;case"rule_delete":e(this).closest("li").remove();break;case"group_insert_before":e(this).closest("li").before(o(U));break;case"group_insert_after":e(this).closest("li").after(o(U));break}e(this).prop("selectedIndex",0)});S='[id^="'+Q+'"]';B.off("change",S).on("change",S,function(){e(this).closest("dl").find("li").each(function(){B.jui_filter_rules("markRuleAsApplied",e(this).attr("id"),false)})});S='[id^="'+R+'"]';B.off("change",S).on("change",S,function(){V=R.length;H=e(this).attr("id").substr(V);E=e(this).prop("selectedIndex")-1;Z=T+H;J=L+H;Y=D+H;ab=e("#"+Z);ac=e("#"+Y);ac.show();if(E>=0){ab.html(t(U,H,e(this).val()));ad=e("#"+J);j(U,H,e(this).val(),ad.val())}else{ab.html("");ac.html("")}B.jui_filter_rules("markRuleAsPending",e(this).closest("li").attr("id"))});S='[id^="'+L+'"]';B.off("change",S).on("change",S,function(){V=L.length;H=e(this).attr("id").substr(V);F=R+H;J=L+H;Y=D+H;P=e("#"+F);ad=e("#"+J);ac=e("#"+Y);I=i(e(this).val());if(I.accept_values!=="yes"){ac.hide()}else{ac.show();if(ac.html()==""){j(U,H,P.val(),ad.val())}}B.jui_filter_rules("markRuleAsPending",e(this).closest("li").attr("id"))})})},getDefaults:function(){return{filters:[],decimal_separator:".",htmlentities:false,containerClass:"filter_rules_container",rulesGroupContainerClass:"rules_group_container",rulesGroupHeaderClass:"rules_group_header",rulesGroupBodyClass:"rules_group_body",rulesGroupConditionContainerClass:"rules_group_condition_container",rulesGroupConditionListClass:"rules_group_condition_list",rulesGroupToolsContainerClass:"rules_group_tools_container",rulesGroupToolsListClass:"rules_group_tools_list",rulesListClass:"rules_list",rulesListLiClass:"rules_list_li",rulesListLiErrorClass:"rules_list_error_li",rulesListLiAppliedClass:"rules_list_applied_li",filterContainerClass:"filter_container",filterListClass:"filter_list",operatorsListContainerClass:"operators_list_container",operatorsListClass:"operators_list",filterValueContainerClass:"filter_value_container",filterInputTextClass:"filter_input_text",filterInputNumberClass:"filter_input_number",filterInputDateClass:"filter_input_date",filterInputCheckboxClass:"filter_input_checkbox",filterInputRadioClass:"filter_input_radio",filterSelectClass:"filter_select",filterGroupListClass:"filter_group_list",filterGroupListItemHorizontalClass:"filter_group_list_item_horizontal",filterGroupListItemVerticalClass:"filter_group_list_item_vertical",ruleToolsContainerClass:"rule_tools_container",ruleToolsClass:"rule_tools_list",noFiltersFoundClass:"no_filters_found",group_dl_id_prefix:"group_",group_condition_id_prefix:"group_cond_",group_tools_id_prefix:"group_tools_",rule_li_id_prefix:"rule_",filters_list_id_prefix:"filters_list_",operators_container_id_prefix:"oper_wrap_",operators_list_id_prefix:"oper_list_",filter_value_container_id_prefix:"flt_wrap_",filter_element_id_prefix:"flt_",filter_element_name_prefix:"flt_name_",rule_tools_id_prefix:"rule_tools_",onValidationError:function(){}}},getOption:function(A){var B=this;return B.data(a)[A]},getAllOptions:function(){var A=this;return A.data(a)},setOption:function(A,D,C){var B=this;B.data(a)[A]=D;if(C){B.jui_filter_rules("init")}},refresh:function(){var A=this;A.jui_filter_rules()},destroy:function(){return e(this).each(function(){var A=e(this);A.removeData(a)})},getRules:function(S,O){var R=this,P=R.attr("id"),B,L,C,A,N,K,I,M,H,Q,D,E=n(R.jui_filter_rules("getOption","rule_li_id_prefix"),P)+"_",J=E.length,G,F;B=R.find("dl").eq(S);L=B.find("dt:first").find("select:first").val();C=B.find("dd:first").find("ul:first").children().get();A=C.length;for(N=0;N<A;N++){K=C[N];I={};if(K.tagName=="LI"){if(e(K).find("select:first").prop("selectedIndex")==0){continue}G=e(K).attr("id").substr(J);I.element_rule_id=e(K).attr("id");I.condition={};M=e(K).find("select:first").val();Q=x(l(P,M));H=e(K).find("select").eq(1).val();I.condition.filterType=Q.filterType;I.condition.field=Q.field;I.condition.operator=H;D=z(P,G,Q,H);if(D===false){return false}else{if(D.length>0){I.condition.filterValue=D}}if(i(H).accept_values=="yes"){if(Q.hasOwnProperty("filter_value_conversion_server_side")){I.filter_value_conversion_server_side=Q.filter_value_conversion_server_side}}I.logical_operator=L;O.push(I)}else{if(K.tagName=="DL"){I.condition=[];I.logical_operator=L;O.push(I);F=O.length-1;S=parseInt(S)+1;R.jui_filter_rules("getRules",S,O[F].condition);u(O)}}}return O},markRuleAsApplied:function(E,B){var C=this,D=e("#"+E),A=C.jui_filter_rules("getOption","rulesListLiAppliedClass");if(B){D.addClass(A)}else{D.removeClass(A)}},markRuleAsError:function(E,A){var C=this,D=e("#"+E),B=C.jui_filter_rules("getOption","rulesListLiErrorClass");if(A){D.addClass(B)}else{D.removeClass(B)}},markRuleAsPending:function(E){var C=this,D=e("#"+E),B=C.jui_filter_rules("getOption","rulesListLiErrorClass"),A=C.jui_filter_rules("getOption","rulesListLiAppliedClass");D.removeClass(B);D.removeClass(A)},markAllRulesAsApplied:function(){var D=this,B=D.jui_filter_rules("getOption","rulesListLiErrorClass"),A=D.jui_filter_rules("getOption","rulesListLiAppliedClass"),C=D.jui_filter_rules("getRules",0,[]);if(C!==false){if(C.length>0){D.find("li").each(function(){if(e(this).find("select:first").prop("selectedIndex")>0){D.jui_filter_rules("markRuleAsError",e(this).attr("id"),false);D.jui_filter_rules("markRuleAsApplied",e(this).attr("id"),true)}})}}},clearAllRules:function(){var A=this,B=A.attr("id");A.find("dl:first").html("");A.data(h)["group_id"]=0;A.data(h)["rule_id"]=0;A.jui_filter_rules("refresh")}};var d=function(F){var E=e("#"+F),G,A,D=E.jui_filter_rules("getOption","filters"),C=D.length,B=[];for(A=0;A<C;A++){B.push(D[A].filterName)}if(k(B)){G="Filternames are not unique...";E.html('<span style="color: red;">ERROR: '+G+"</span>");e.error(G)}};var n=function(B,A){return B+A};var k=function(C){var B={},A=C.length,D;for(D=0;D<A;D++){if(B[C[D]]===true){return true}B[C[D]]=true}return false};var b=function(A){if(A){return jQuery("<div />").text(A).html()}else{return""}};var f=function(A){if(A){return e("<div />").html(A).text()}else{return""}};var x=function(B){var A={},C;for(C in B){if(B.hasOwnProperty(C)){if(B[C]!==""){A[C]=B[C]}}}return A};var u=function(B){var C,D,A=B.length;for(C=0;C<A;C++){D=B[C].condition;if(e.isArray(D)){if(D.length==0){B.splice(C,1)}else{u(D)}}}};var s=function(A){return A.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")};var l=function(E,F){var D=e("#"+E),A,C=D.jui_filter_rules("getOption","filters"),B=C.length,G=undefined;for(A=0;A<B;A++){if(C[A].filterName==F){G=C[A];break}}return G};var y=function(E,G){var C=e("#"+E),B=C.jui_filter_rules("getOption","filters"),A,H,J,I=r.length,F,D=[],K;A=l(E,G);H=A.filterType;J=(A.excluded_operators===undefined?[]:A.excluded_operators);for(F=0;F<I;F++){if(e.inArray(r[F].type,J)>-1){continue}if(e.inArray(H,r[F].apply_to)>-1){K={};K.operator_type=r[F].type;K.operator_label=rsc_jui_fr["operator_"+r[F].type];K.group=r[F].group;D.push(K)}}return D};var i=function(C){var B,A=r.length,D=undefined;for(B=0;B<A;B++){if(r[B].type==C){D=r[B];break}}return D};var v=function(E){var C=e("#"+E),B,F=C.jui_filter_rules("getOption","rulesGroupConditionContainerClass"),A=C.jui_filter_rules("getOption","rulesGroupConditionListClass"),D="";B=n(C.jui_filter_rules("getOption","group_condition_id_prefix"),E)+"_"+C.data(h)["group_id"];D+='<div class="'+F+'">';D+='<select id="'+B+'" class="'+A+'">';D+='<option value="AND">'+rsc_jui_fr.rules_group_AND+":</option>";D+='<option value="OR">'+rsc_jui_fr.rules_group_OR+":</option>";D+="</select>";D+="</div>";return D};var q=function(B){var A=e("#"+B),F=parseInt(A.data(h)["rule_id"]),E=A.jui_filter_rules("getOption","rulesGroupToolsContainerClass"),I=A.jui_filter_rules("getOption","rulesGroupToolsListClass"),C=n(A.jui_filter_rules("getOption","group_tools_id_prefix"),B)+"_"+F,D=(F==0?' disabled="disabled"':""),G=(e.browser.msie&&parseInt(e.browser.version)<9?"":" tools_list_shrink"),H="";H+='<div class="'+E+'">';H+='<select id="'+C+'" class="'+I+G+'">';H+='<option value="please_select">'+rsc_jui_fr.tools_please_select+"</option>";H+='<optgroup label="'+rsc_jui_fr.rule+'">';H+='<option value="rule_insert_before"'+D+">"+rsc_jui_fr.rule_insert_before+"</option>";H+='<option value="rule_insert_after"'+D+">"+rsc_jui_fr.rule_insert_after+"</option>";H+='<option value="rule_insert_inside">'+rsc_jui_fr.rule_insert_inside+"</option>";H+="</optgroup>";H+='<optgroup label="'+rsc_jui_fr.group+'">';H+='<option value="group_insert_before"'+D+">"+rsc_jui_fr.group_insert_before+"</option>";H+='<option value="group_insert_after"'+D+">"+rsc_jui_fr.group_insert_after+"</option>";H+='<option value="group_insert_inside">'+rsc_jui_fr.group_insert_inside+"</option>";H+='<option value="group_delete"'+D+">"+rsc_jui_fr.group_delete+"</option>";H+="</optgroup>";H+="</select>";H+="</div>";return H};var p=function(E){var D=e("#"+E),I=parseInt(D.data(h)["rule_id"]),C=D.jui_filter_rules("getOption","filters"),J=C.length,H=D.jui_filter_rules("getOption","filterContainerClass"),B=D.jui_filter_rules("getOption","filterListClass"),A=n(D.jui_filter_rules("getOption","filters_list_id_prefix"),E)+"_"+I,F,G="";G+='<div class="'+H+'">';G+='<select id="'+A+'" class="'+B+'">';G+='<option value="no_filter">'+rsc_jui_fr.filter_please_select+"</option>";for(F=0;F<J;F++){G+='<option value="'+C[F].filterName+'">'+C[F].filterLabel+"</option>"}G+="</select>";G+="</div>";return G};var t=function(E,K,H){var B=e("#"+E),N=n(B.jui_filter_rules("getOption","operators_container_id_prefix"),E)+"_"+K,I=e("#"+N),D=B.jui_filter_rules("getOption","operatorsListClass"),F=n(B.jui_filter_rules("getOption","operators_list_id_prefix"),E)+"_",M=F+K,C,G,J,L="",A="";C=y(E,H);J=C.length;L+='<select id="'+M+'" class="'+D+'">';for(G=0;G<J;G++){if(C[G].group!==A){L+='<optgroup label="&raquo;">';A=C[G].group}L+='<option value="'+C[G].operator_type+'">'+C[G].operator_label+"</option>";if(G<J-1&&C[parseInt(G)+1].group!==A){L+="</optgroup>"}}L+="</select>";I.html(L)};var j=function(T,K,ad,R){var al=e("#"+T),am=i(R),D=n(al.jui_filter_rules("getOption","filter_value_container_id_prefix"),T)+"_"+K,af=e("#"+D),Q=al.jui_filter_rules("getOption","filters"),Z=x(l(T,ad)),U=Z.filterType,B=Z.filter_interface,H=B.length,ao,E,F,N,L="",O,aa,C=["id","name"],S="",an,ag,W,aj,X="",A="no",ak,J=al.jui_filter_rules("getOption","filterGroupListClass"),ai=al.jui_filter_rules("getOption","filterGroupListItemHorizontalClass"),ae=al.jui_filter_rules("getOption","filterGroupListItemVerticalClass"),I="";if(am.accept_values!=="yes"){af.html("");return true}if(Z.hasOwnProperty("lookup_values_ajax_url")){X=Z.lookup_values_ajax_url;e.ajax({url:X,success:(function(aq){an=e.parseJSON(aq);af.html(V());M()})})}else{if(Z.hasOwnProperty("lookup_values")){an=Z.lookup_values}af.html(V());M()}function V(){for(ao=0;ao<H;ao++){E=B[ao].filter_element;O=x(B[ao].filter_element_attributes);if(E=="input"){L=O.type}P();if(L=="checkbox"||L=="radio"){ap();ag=an.length;I+='<ul class="'+J+'">';for(W=0;W<ag;W++){I+='<li class="'+ak+'">';I+="<"+E;ac(W);I+=' id="'+F+'"';if(L=="radio"){ah();I+=' name="'+N+'"'}Y();I+=' value="'+an[W]["lk_value"]+'"';aj=(an[W]["lk_selected"]=="yes"?' checked="checked"':"");I+=aj;I+=">";I+='<label for="'+F+'">'+an[W]["lk_option"]+"</label>";I+="</li>"}I+="</ul>"}else{I+="<"+E;ac(ao);I+=' id="'+F+'"';Y();I+=">";if(E=="select"){G()}if(E=="div"){I+="</div>"}}}return I}function ac(aq){F=n(al.jui_filter_rules("getOption","filter_element_id_prefix"),T)+"_"+K+"_"+aq}function ah(){N=n(al.jui_filter_rules("getOption","filter_element_name_prefix"),T)+"_"+K}function P(){if(E=="input"){if(L=="text"){C=["id","name"]}else{if(L=="radio"){C=["id","name","value","checked"]}else{if(L=="checkbox"){C=["id","name","value","checked"]}}}}else{if(E=="select"){C=["id","name","value"]}}}function ab(){var aq="";S="";if(E=="input"){if(L=="text"){if(U=="text"){aq="filterInputTextClass"}else{if(U=="number"){aq="filterInputNumberClass"}else{if(U=="date"){aq="filterInputDateClass"}}}}else{if(L=="radio"){aq="filterInputRadioClass"}else{if(L=="checkbox"){aq="filterInputCheckboxClass"}}}}else{if(E=="select"){aq="filterSelectClass"}}if(aq!==""){S=al.jui_filter_rules("getOption",aq)}}function Y(){for(aa in O){if(O.hasOwnProperty(aa)){if(e.inArray(aa,C)>-1){continue}I+=" "+aa+'="'+O[aa]+'"'}}if(!O.hasOwnProperty("class")){ab();if(S!==""){I+=' class="'+S+'"'}}}function G(){ag=an.length;for(W=0;W<ag;W++){aj=(an[W]["lk_selected"]=="yes"?' selected="selected"':"");I+='<option value="'+an[W]["lk_value"]+'"'+aj+">"+an[W]["lk_option"]+"</option>"}I+="</select>"}function ap(){A="no";if(B[ao].hasOwnProperty("vertical_orientation")){A=B[ao].vertical_orientation}ak=(A=="yes"?ae:ai)}function M(){if(L=="checkbox"||L=="radio"){return true}for(ao=0;ao<H;ao++){if(!B[ao].hasOwnProperty("filter_widget")){continue}F=n(al.jui_filter_rules("getOption","filter_element_id_prefix"),T)+"_"+K+"_"+ao;var ar=e("#"+F);var at=B[ao]["filter_widget"];var aq=B[ao]["filter_widget_properties"];if(at=="datepicker"){ar.datepicker(aq)}if(at=="datetimepicker"){ar.datetimepicker(aq)}if(at=="autocomplete"){ar.autocomplete(aq)}if(at=="spinner"){ar.spinner(aq)}if(at=="slider"){ar.slider(aq)}}return true}return true};var c=function(E){var C=e("#"+E),B=parseInt(C.data(h)["rule_id"]),H=C.jui_filter_rules("getOption","ruleToolsContainerClass"),G=C.jui_filter_rules("getOption","ruleToolsClass"),A=n(C.jui_filter_rules("getOption","rule_tools_id_prefix"),E)+"_"+B,F=(e.browser.msie&&parseInt(e.browser.version)<9?"":" tools_list_shrink"),D="";D+='<div class="'+H+'">';D+='<select id="'+A+'" class="'+G+F+'">';D+='<option value="please_select">'+rsc_jui_fr.tools_please_select+"</option>";D+='<optgroup label="'+rsc_jui_fr.rule+'">';D+='<option value="rule_insert_before">'+rsc_jui_fr.rule_insert_before+"</option>";D+='<option value="rule_insert_after">'+rsc_jui_fr.rule_insert_after+"</option>";D+='<option value="rule_clear">'+rsc_jui_fr.rule_clear+"</option>";D+='<option value="rule_delete">'+rsc_jui_fr.rule_delete+"</option>";D+="</optgroup>";D+='<optgroup label="'+rsc_jui_fr.group+'">';D+='<option value="group_insert_before">'+rsc_jui_fr.group_insert_before+"</option>";D+='<option value="group_insert_after">'+rsc_jui_fr.group_insert_after+"</option>";D+="</optgroup>";D+="</select>";D+="</div>";return D};var o=function(E){var B=e("#"+E),H=B.jui_filter_rules("getOption","group_dl_id_prefix"),G,J,I=B.jui_filter_rules("getOption","rulesGroupContainerClass"),C=B.jui_filter_rules("getOption","rulesGroupHeaderClass"),A=B.jui_filter_rules("getOption","rulesGroupBodyClass"),D=B.jui_filter_rules("getOption","rulesListClass"),F="";J=parseInt(B.data(h)["group_id"])+1;B.data(h)["group_id"]=J;G=n(H,E)+"_"+J;F+='<dl id="'+G+'" class="'+I+'">';F+='<dt class="'+C+'">';F+=v(E);F+=q(E);F+="</dt>";F+='<dd class="'+A+'">';F+='<ul class="'+D+'">';F+=m(E);F+="</ul>";F+="</dd>";F+="</dl>";return F};var m=function(D){var C=e("#"+D),G=C.jui_filter_rules("getOption","rulesListLiClass"),F=C.jui_filter_rules("getOption","operatorsListContainerClass"),E=C.jui_filter_rules("getOption","filterValueContainerClass"),L=n(C.jui_filter_rules("getOption","rule_li_id_prefix"),D)+"_",K=n(C.jui_filter_rules("getOption","operators_container_id_prefix"),D)+"_",I=n(C.jui_filter_rules("getOption","filter_value_container_id_prefix"),D)+"_",J,M,A,H,B="";H=parseInt(C.data(h)["rule_id"])+1;C.data(h)["rule_id"]=H;M=K+H;A=I+H;J=L+H;B+='<li id="'+J+'" class="'+G+'">';B+=p(D);B+='<div id="'+M+'" class="'+F+'">';B+="</div>";B+='<div id="'+A+'" class="'+E+'">';B+="</div>";B+=c(D);B+="</li>";return B};var z=function(Q,J,V,N){var ad=e("#"+Q),R=V.filterType,D=V.filter_interface,I=D.length,af,F,E=n(ad.jui_filter_rules("getOption","filter_value_container_id_prefix"),Q)+"_"+J,aa=e("#"+E),C=ad.jui_filter_rules("getOption","filter_element_id_prefix"),G,L="",M,U,ae=i(N),Y=n(ad.jui_filter_rules("getOption","rule_li_id_prefix"),Q)+"_"+J,ah=e("#"+Y),H=ad.jui_filter_rules("getOption","rulesListLiErrorClass"),T=ad.jui_filter_rules("getOption","decimal_separator"),ai=new RegExp(s(T),"g"),aj=ad.jui_filter_rules("getOption","htmlentities"),al,W=[],P,Z,S=[],am,ab="",ac,B=[],K,ak;ah.removeClass(H);if(ae.accept_values!=="yes"){return W}for(af=0;af<I;af++){if(D[af].hasOwnProperty("returns_no_value")){if(D[af]["returns_no_value"]=="yes"){continue}}F=D[af].filter_element;M=D[af].filter_element_attributes;if(F=="input"){L=M.type;if(L=="text"){G=O(af);al=e("#"+G);W.push(al.val())}if(L=="checkbox"||L=="radio"){U=e('[id^="'+n(C,Q)+"_"+J+'_"]');U.each(function(){if(e(this).is(":checked")){W.push(e(this).val())}S.push(e(this))})}}if(F=="select"){G=O(af);al=e("#"+G);if(M.hasOwnProperty("multiple")){W=al.val()}else{W.push(al.val())}}}if(L=="checkbox"||L=="radio"){if(e("input:checked",aa).length==0){X();return false}}P=W.length;for(Z=0;Z<P;Z++){if(e.trim(W[Z]).length==0){X();return false}}if(R=="number"){P=W.length;for(Z=0;Z<P;Z++){W[Z]=W[Z].replace(ai,".");if(!e.isNumeric(W[Z])){ah.addClass(H);ad.triggerHandler("onValidationError",{err_code:"filter_error_2",err_description:rsc_jui_fr.error_invalid_number,elem_filter:A()});return false}}}if(R=="date"){P=W.length;if(V.hasOwnProperty("validate_dateformat")){for(Z=0;Z<P;Z++){if(moment(W[Z],V.validate_dateformat).isValid()==false){ah.addClass(H);ad.triggerHandler("onValidationError",{err_code:"filter_error_3",err_description:rsc_jui_fr.error_invalid_datetime,elem_filter:A()});return false}}}}if(V.hasOwnProperty("filter_value_conversion")){am=V.filter_value_conversion;ab=am.function_name;ac=am.args;K=ac.length;P=W.length;for(Z=0;Z<P;Z++){B=[];for(ak=0;ak<K;ak++){if(ac[ak].hasOwnProperty("filter_value")){B.push(W[Z])}if(ac[ak].hasOwnProperty("value")){B.push(ac[ak]["value"])}}try{W[Z]=window[ab].apply(null,B)}catch(ag){ad.jui_filter_rules("markRuleAsError",ah.attr("id"),true);ad.triggerHandler("onValidationError",{err_code:"filter_error_0",err_description:rsc_jui_fr.error_converting_value+":\n\n"+ag.message,elem_filter:A()});return false}}}if(R!=="number"){if(aj){P=W.length;for(Z=0;Z<P;Z++){W[Z]=b(W[Z])}}}function O(an){return n(C,Q)+"_"+J+"_"+an}function X(){ah.addClass(H);ad.triggerHandler("onValidationError",{err_code:"filter_error_1",err_description:rsc_jui_fr.error_no_value_given,elem_filter:A()})}function A(){if(L=="checkbox"||L=="radio"){if(Z==undefined){Z=0}return S[Z]}else{return al}}return W};e.fn.jui_filter_rules=function(B){if(this.size()!=1){var A="You must use this plugin ("+a+") with a unique element (at once)";this.html('<span style="color: red;">ERROR: '+A+"</span>");e.error(A)}if(w[B]){return w[B].apply(this,Array.prototype.slice.call(arguments,1))}else{if(typeof B==="object"||!B){return w.init.apply(this,arguments)}else{e.error("Method "+B+" does not exist on jQuery."+a)}}}})(jQuery);
